// Frame.cpp: implementation of the CFrame class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VideoDB.h"
#include "Frame.h"

#include "math.h"
#include "video.h"
#include "RGB2HSV.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

long bmp_to_jpg(char *bmp,char * jpg,long qa);
extern CVideo * g_video;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFrame::CFrame()
{

}
//-------------------------------------------------
CFrame::~CFrame()
{
	int i,j;
	for (i=0; i < height/4; i++)
		for (j=0; j < width/4; j++)
			delete (block4[i][j]);

	for (i=0; i < height/8; i++)
		for (j=0; j < width/8; j++)
			delete (block8[i][j]);

	for (i=0; i< height; i++)
		free(Y[i]);
	free(Y);

	for (i=0; i<height/2; i++)
	{
		free(U[i]);
		free(V[i]);
	}
	free (U);
	free (V);
}

//-------------------------------------------------
void CFrame::readFrame(CFile* & f, int &eof)
{
	WORD OutPicWidth, OutPicHeight;
	long lItemNum;
	int i,j;

	lItemNum=MpvDecoder.GetCurFrame(pnOutBuf,&OutPicWidth,&OutPicHeight,0);
	for (i=0; i	< OutPicHeight; i++)
		for (j=0 ; j< OutPicWidth; j++)
		{
			Y[i][j] = pnOutBuf[i*OutPicWidth + j];
		}

	lItemNum=MpvDecoder.GetCurFrame(pnOutBuf,&OutPicWidth,&OutPicHeight,1);
	for (i=0; i	< OutPicHeight; i++)
		for (j=0 ; j< OutPicWidth; j++)
		{
			U[i][j] = pnOutBuf[i*OutPicWidth + j];
		}

	lItemNum=MpvDecoder.GetCurFrame(pnOutBuf,&OutPicWidth,&OutPicHeight,2);
	for (i=0; i	< OutPicHeight; i++)
		for (j=0 ; j< OutPicWidth; j++)
		{
			V[i][j] = pnOutBuf[i*OutPicWidth + j];
		}

	// if frame type is I frame then save its offset because it will be the start
	// offset of the shot following it
	// write offset information to the temporary file
/*	PICTURERECORD pictureRecord;
	MpvDecoder.RecordCurPicture(&pictureRecord,BASELAYER);
	long packetFileOffset = pictureRecord.PicInfo.CurPicturePckPos.lDataFilePos;
	long picturePacketOffset = pictureRecord.PicInfo.lCurPicturePckOffset;
	char l[1000];
	sprintf(l,"%d %d %ld\n",id,pHeaderData->PictureHeader.nPictureCodingType,packetFileOffset+picturePacketOffset);
	g_outputFiles[TEMPFILE]->Write(l,strlen(l));

	if (pHeaderData->PictureHeader.nPictureCodingType==I_TYPE)
		g_lastIFrameOffset = packetFileOffset + picturePacketOffset;*/

	if (g_sceneCuts || g_keyFrames)
	{
		// check whether we should take the offset of the frame or not (as an end of shot frame)
		/*
		if (id == g_shotEnd -1)
		{
			MpvDecoder.RecordCurPicture(&pictureRecord,BASELAYER);
			packetFileOffset = pictureRecord.PicInfo.CurPicturePckPos.lDataFilePos;
			picturePacketOffset = pictureRecord.PicInfo.lCurPicturePckOffset;

			g_curSceneCutOffset = packetFileOffset + picturePacketOffset;
		}
		*/
		// check whether the frame should be saved in JPG format of not
		if (g_video->HD[id] == -1  || g_video->HD[id] == -2)	// keyframe or scenecut
		{
			char bmpFileName[200], jpgFileName[200], temp[10];

			lItemNum=MpvDecoder.GetCurFrame(pnOutBuf,&OutPicWidth,&OutPicHeight,BMP);
			if (lItemNum>0)
			{
				FILE *pfFile;
				pfFile=fopen(g_metadataFile + "temp.bmp","wb");
				if (pfFile==NULL)
				{
					AfxMessageBox("ERROR : BMP File open failed !");
					return;
				}
				fwrite(pnOutBuf,sizeof(BYTE),lItemNum,pfFile);
				fclose(pfFile);

				// convert the BMP file to JPG format
				strcpy(bmpFileName,g_metadataFile);
				strcat(bmpFileName,"temp.bmp");
				strcpy(jpgFileName,g_metadataFile);
				sprintf(temp,"%d.jpg",id);
				strcat(jpgFileName,temp);
				bmp_to_jpg(bmpFileName,jpgFileName,75);
			}

			// write a line in the SQL File withe file name
			char s[1000];
			int shotNo;
			if (id >= g_shotEnd)
				shotNo = g_shotNo + 1;
			else
				shotNo = g_shotNo;

			if (g_video->HD[id] == -2)	// key frame
			{
				sprintf(s,"%d\t%d\t%d\t[image('format jpeg')]'%s'\n",g_videoId,shotNo,id,jpgFileName);
				g_outputFiles[KFDATFILE]->Write(s,strlen(s));
			}
			else	// scne cut - Must calculatte the frame offset
			{
				/*
				if (!g_lastSceneCutOffset)
				{
					g_lastSceneCutOffset= g_lastIFrameOffset;
					g_lastSceneCutOffset2 = 0;
				}
				else
				{
					// the value of g_lastSceneCutOffset has not yet been written to the file
					g_lastSceneCutOffset2= g_lastIFrameOffset;
				}
				*/
			}
		}
	}
}
//-------------------------------------------------

CFrame::CFrame(int frameId, int frameH, int frameW)
{
	id = frameId;
	CHcalculated = false;
	height = frameH;
	width = frameW;

	int i,m,n;

	// Create the YUV arrays
	Y = (BYTE **) malloc(sizeof(BYTE*) * height);
	for (i=0; i < height ; i++)
	{
		Y[i] = (BYTE*) malloc(sizeof(BYTE) * width);
	}

	U = (BYTE **) malloc(sizeof(BYTE*) * height/2);
	V = (BYTE **) malloc(sizeof(BYTE*) * height/2);
	for (i=0; i < height/2 ; i++)
	{
		U[i] = (BYTE*) malloc(sizeof(BYTE) * width/2);
		V[i] = (BYTE*) malloc(sizeof(BYTE) * width/2);
	}

	
	// create the 4*4 blocks in that frame
	for (m=0; m < height/4; m++)
	{
		for (n=0 ; n < width/4; n++)
		{
			block4[m][n] = new CBlock4(m,n);
		}
	}

	for (m=0; m < height/8; m++)
	{
		for (n=0 ; n < width/8; n++)
		{
			block8[m][n] = new CBlock8(m,n);
		}
	}
}
//-------------------------------------------------

void CFrame::calculateColorHD()
{
	int yCH[32], uCH[32],vCH[32]; // CH of the current frame
	int yyCH[32],uuCH[32],vvCH[32];  // CH of the reference frame
    float yDiff,uDiff,vDiff;	// color histogram diffrence in the y,u,v directions

	// initialize the used counters
	yDiff=uDiff=vDiff=0;
	for (int j=0;j<32;j++)
	{
		yCH[j]=uCH[j]=vCH[j]=yyCH[j]=uuCH[j]=vvCH[j]=0;
	}

	// get the CH of y,u,v of the current frame and of the reference frame
	for (int x = 0; x < height ;x++)
	{
		for (int y=0; y < width; y++)
		{
			yCH[(int) Y[x][y]/8]++;
			yyCH[(int) ref->Y[x][y]/8]++;
			
			if (x < height/2 && y < width/2)
			{
				uCH[(int) U[x][y]/8]++;
				uuCH[(int) ref->U[x][y]/8]++;

				vCH[(int) V[x][y]/8]++;
				vvCH[(int) ref->V[x][y]/8]++;
			}
		}
	}


	// get the color histogram difference
	for (int i =0; i < 32; i++)
	{
		if (yCH[i]+yyCH[i])
			yDiff += (float) ((yCH[i]-yyCH[i])*(yCH[i]-yyCH[i]))/ ((yCH[i]+yyCH[i])*(yCH[i]+yyCH[i]));
		if (uCH[i]+uuCH[i])
			uDiff += (float) ((uCH[i]-uuCH[i])*(uCH[i]-uuCH[i]))/ ((uCH[i]+uuCH[i])*(uCH[i]+uuCH[i]));
		if (vCH[i]+vvCH[i])
			vDiff += (float) ((vCH[i]-vvCH[i])*(vCH[i]-vvCH[i]))/ ((vCH[i]+vvCH[i])*(vCH[i]+vvCH[i]));
	}

	// get the final histogramDiff
	HD = (yDiff+uDiff+vDiff);
}
//---------------------------------------------------------
void CFrame::motionEstimation()
{
	/* work based on 8*8 block */
	for (int i=0; i < height/8; i++)
		for (int j=0; j< width/8; j++)
			estimateBlockMotion(i,j);
}
//--------------------------------------------------------------------
void CFrame::estimateBlockMotion(int i,int j)
{
	/* The motion estimation works on an 8*8 blocks to specify their moviing directions
	using a step of 16 search the blocks arround with the least distance if the min
	> 4 * FCONThreshold then reduce the step to step/2. continue until find a block
	with difference < 4 * FCONThreshold or step = 1 then take the min. getting the
	vx and vy indicates the direction where the block moves we can approximate the
	direction to one of the 8 directions according to the sign of vx, vy
	*/
	
	int k, vx, vy, step, done;
	int finalvx=0; int finalvy=0;
	int x=i*8;int y=j*8;
	float FD[9];

	done = 0;		// =1 when the vx or vy is set otherwise = 0
	step = 16;		// initial step for the block

	while(step>=1) 
	{
		// compare with the same frame in the reference block
		if((FD[0]=getDifference(i,j,8,0,0)) < 4 * FCONThreshold)	
		{
			block8[i][j]->vx=0;
			block8[i][j]->vy=0;
			done = 1;
			break;
		}
		else // get the minumum of the 9 points in the search range
		{
			FD[1]=getDifference(i,j,8,-step,-step);
			FD[2]=getDifference(i,j,8,step,step);
			FD[3]=getDifference(i,j,8,-step,step);
			FD[4]=getDifference(i,j,8,step,-step);	
			FD[5]=getDifference(i,j,8,0,-step);
			FD[6]=getDifference(i,j,8,0,step);
			FD[7]=getDifference(i,j,8,-step,0);
			FD[8]=getDifference(i,j,8,step,0);
					
			k = getMin(FD, 9);

			switch(k)
			{
			case 0:vx=0;vy=0;break; 
			case 1:vx=-step;vy=-step;break;
			case 2:vx=step;vy=step;break;
			case 3:vx=-step;vy=step;break;
			case 4:vx=step;vy=-step;break;
			case 5:vx=0;vy=-step;break;
			case 6:vx=0;vy=step;break;
			case 7:vx=-step;vy=0;break;
			case 8:vx=step;vy=0;break;
			}

			step = step /2;	
			finalvx += vx;
			finalvy += vy;
			
			if (FD[k] < 4 * FCONThreshold)
			{
				block8[i][j]->vx = finalvx;
				block8[i][j]->vy = finalvy;
				done = 1;
				break;
			}
		}
	//new x,y for the next step
	x=x+vx;
	y=y+vy;
	}
	//after all steps if not found then take the minimum anyway
	if (!done)
	{
		block8[i][j]->vx = finalvx;
		block8[i][j]->vy = finalvy;
	}

	// get an approximate direction for the whole block according to vx, vy signs
	setBlockDirection(i,j);
}
//------------------------------------------------
float CFrame::getDifference(int m, int n, int blockSize, int stepx, int stepy)
{
	/* return the Difference between the block m,n with size blockSize with
	the block far by stepx and stepy in the reference frame */
	float diff = 0;
	int x = m * blockSize;
	int y = n * blockSize;

	if (x+stepx<0 || y+stepy<0 || x+stepx+blockSize>height || y+stepy+blockSize> width)
		return INF;
	
	for (int i=0; i< blockSize; i++)
	{
		for (int j=0; j < blockSize; j++)
		{
			diff += getAbsolute((float)Y[x+i][y+j] - (float)ref->Y[x+i+stepx][y+j+stepy]);
		}	
	}
	return (diff);
}
//-----------------------------------------------------------------
void CFrame::calculateCH()
{
	CHcalculated = true;

	// USE Y, U, and V to calculate color histogram
	float temph[YCOLORRANGES][UCOLORRANGES][VCOLORRANGES];
	memset(temph,0,COLQUANT*4);
	for (int x = 0; x < height ;x++)
	{
		for (int y= 0; y < width ;y++)
		{
			temph[(int) Y[x][y]/(256/YCOLORRANGES)][(int) U[x/2][y/2]/(256/UCOLORRANGES)][(int) V[x/2][y/2]/(256/VCOLORRANGES)]++;
		}
	}

	memcpy(CH,temph,COLQUANT*4);
	int M = height * width;
	for (int j=0; j < COLQUANT; j++)
		CH[j] /= (float) M;
}
//------------------------------------------------------------------------

void CFrame::setBlockDirection(int i, int j)
{
	double angle;
	double pi = 3.1415926535;
	
	if (!block8[i][j]->vy && !block8[i][j]->vx)
		block8[i][j]->direction = STATIONARY;
	else
	{
		angle = (180 * atan2(block8[i][j]->vy,block8[i][j]->vx))/pi;	
		// round the angle to one decimal place
		angle = (int)(angle * 10)/10.0;

		if (angle>= -22.5 && angle < 22.5)
			block8[i][j]->direction = RIGHT;
		else if (angle >=22.5 && angle < 67.5)
			block8[i][j]->direction = RIGHTUP;
		else if (angle >= 67.5 && angle < 112.5)
			block8[i][j]->direction = UP;
		else if (angle >= 112.5 && angle < 157.5)
			block8[i][j]->direction = LEFTUP;
		else if (angle >= 157.5 && angle <= 180 || angle >=-180 && angle < -157.5)
			block8[i][j]->direction = LEFT;
		else if (angle >= -157.5 && angle < -112.5)
			block8[i][j]->direction = LEFTDOWN;
		else if (angle >= -112.5 && angle < -67.5)
			block8[i][j]->direction = DOWN;
		else if (angle >= -67.5 && angle < -22.5)
			block8[i][j]->direction = RIGHTDOWN;
		else
			AfxMessageBox("here");
	}
	/*if (finalvx ==0)
		if (finalvy == 0)
			block8[i][j]->direction = STATIONARY;
		else if (finalvy > 0)
			block8[i][j]->direction = UP;
		else
			block8[i][j]->direction = DOWN;
	else if (finalvx > 0)
		if (finalvy == 0)
			block8[i][j]->direction = RIGHT;
		else if (finalvy > 0)
			block8[i][j]->direction = RIGHTUP;
		else 
			block8[i][j]->direction = RIGHTDOWN;
	else		// vx < 0
		if (finalvy == 0)
			block8[i][j]->direction = LEFT;
		else if (finalvy > 0)
			block8[i][j]->direction = LEFTUP;
		else 
			block8[i][j]->direction = LEFTDOWN;

*/
}
//-------------------------------------------------------------------
void CFrame::spatialSegmentation()
{
	float maxLCON=0;
	int i,j;

	//calculate the MEAN and LCON for each block in the frame
	for (int m=0; m<height/4;m++)
		for (int n=0; n < width/4; n++)
		{
			block4[m][n]->mean = 0;
			block4[m][n]->LCON = 0;
			for(i=0; i < 4; i++)
				for(j=0; j<4 ; j++)
				{
					int x = m*4 +i ;
					int y = n*4 +j;
					block4[m][n]->mean += Y[x][y];
				}
			block4[m][n]->mean = block4[m][n]->mean/16;

			for(i=0; i < 4; i++)
				for(j=0; j<4 ; j++)
				{
					int x = m*4 +i ;
					int y = n*4 +j;
					block4[m][n]->LCON += getAbsolute(Y[x][y]-block4[m][n]->mean);
				}
			block4[m][n]->LCON = block4[m][n]->LCON/16;

			if (block4[m][n]->LCON > maxLCON)
				maxLCON = block4[m][n]->LCON;

		}

	int *f;
	
	// CALCULATE THE LCON THRESHOLD
	maxLCON = maxLCON + 1;
	f = (int *) malloc(sizeof(int) * (int)maxLCON);
	for (i=0; i < (int) maxLCON;i++) f[i]=0;

	// Calculate the frequencies of the block means
	for (i=0;i<height/4;i++)
		for (j=0; j<width/4;j++)
		{
			f[(int) block4[i][j]->LCON]++;
		}

	// we will cut the array of frequency after the frequencies that construct
	// 95% of the frequencies
	float totalFreq=0;
	float M = height * width /16;
	for (i=0;i < (int) maxLCON; i++)
	{
		totalFreq += f[i];
		if (totalFreq / M > 0.97)
		{
			maxLCON = i;
			break;
		}
	}

	// Calculate threshold
	LCONThreshold = (float) getThreshold(f,(int) maxLCON,(float) ((height * width)/16 - 1));
	free(f);	
}
//--------------------------------------------------------------------

void CFrame::temporalSegmentation()
{
	float maxLCON=0;
	int i,j;

	//calculate the MEAN and LCON for each block in the frame
	for (int m=0; m<height/4;m++)
		for (int n=0; n < width/4; n++)
		{
			// get the difference between block m,n of size 4 and same block in ref frame
			block4[m][n]->FCON = getDifference(m,n,4,0,0);	
		}

	int f[256];
	
	for (i=0; i < 256;i++) f[i]=0;

	// Calculate the frequencies of the block FCON where < 256
	for (i=0;i<height/4;i++)
		for (j=0; j<width/4;j++)
		{
			if ((int) block4[i][j]->FCON < 256) 
				f[(int) block4[i][j]->FCON]++;
		}

	// Calculate threshold
	FCONThreshold = (float) getThreshold(f,256,(float) ((height * width)/16 - 1));
}
//----------------------------------------------------
void CFrame::copyFrame(CFrame *newFrame)
{
	// copy the contents of the current frame to new frame
	int i,j;
	newFrame->id = id;
	for (i=0; i<height; i++)
		for (j=0; j<width;j++)
			newFrame->Y[i][j] = Y[i][j];

	for (i=0; i<height/2; i++)
		for (j=0; j<width/2;j++)
		{
			newFrame->U[i][j] = U[i][j];
			newFrame->V[i][j] = V[i][j];
		}
}
////////////////////////////////////////////////////////////////////////
// Those  functions will return a string of features and also return the
// values in the h array (h has to be allocated before calling the functions
///////////////////////////////////////////////////////////////////////
char * CFrame::getCH(float *h)
{
	char l[1000];

	if (!CHcalculated)
		calculateCH();

	memcpy(h,CH,COLQUANT*4);
	strcpy(l,getStringFromArray(CH,COLQUANT));
	strcat(l,"\n");

	return l;
}
//---------------------------------------------------------------------------
char * CFrame::getDC()
{
	// from the array of histogram values CH return the elements of the MPEG 7
	// descriptor of the dominant colors.
	char l[1000];

	if (!CHcalculated)
		calculateCH();
	
	strcpy(l,getDCFromCH(CH));
	strcat(l,"\n");
	return (l);
}
//---------------------------------------------------------------------------
char * CFrame::getCM(float *h)
{
	float m, v;
	int M = height * width;
	char l[100];
	int i,j;

	m = v = 0;
	for (i=0; i< height; i++)
	{	
		for (j=0;j < width; j++)
		{
			m += Y[i][j];
		}
	}
	
	m = m / M;
	for (i=0; i< height; i++)
	{
		for (j=0; j < width; j++)
		{
			v += getAbsolute(Y[i][j] - m);
		}
	}
	v = v / M;

	h[0] = m;
	h[1] = v;
	sprintf(l," %f %f\n",m,v);
	return l;
}
//----------------------------------------------------------------------------

char * CFrame::getCHHSV(float *h)
{
	char l[10000];
	int dim;
	const int M = MImage_W * MImage_H;
	unsigned char r[M], g[M], b[M];
	float *h2;

	// convert YUV2R_G_B
	YUV2R_G_B(this,r,g,b);
	RGB2HSV *rgb2hsv = new RGB2HSV();

	// get the color histogram from HSV format
	h2 = rgb2hsv->R_G_B2HSVHistogram(r,g,b,height * width,&dim);
	if (dim != HSV_DIM)
		AfxMessageBox("error in HSV CH dimension");

	memcpy(h,h2,HSV_DIM*4);
	strcpy(l,getStringFromArray(h,HSV_DIM));
	strcat(l,"\n");

	delete (rgb2hsv);
	return l;
}
//----------------------------------------------------------------------------
char * CFrame::getCL(float *h)
{
	const int NOOFBLOCKS = NOOFHBLOCKS*NOOFVBLOCKS;
	float CHblock[NOOFBLOCKS][COLQUANT],ch[COLQUANT];

	// initialize color histogram for each frame
	memset(CHblock,0,CL_DIM*4);
	int blockW = width/NOOFHBLOCKS;
	int blockH = height/NOOFVBLOCKS;
	int i,j,b;

	// calculate color histogram for each block
	for(i=0;i<NOOFVBLOCKS;i++)
	{
		for	(j=0; j< NOOFHBLOCKS;j++)
		{
			b = i*4 +j;
			calculateCH(ch,i*blockH,(i+1)*blockH,j*blockW,(j+1)*blockW);
			memcpy(CHblock[b],ch,COLQUANT*4);
		}
	}

	memcpy(h,CHblock,CL_DIM*4);

	char l[10000];
	strcpy(l,"");
	for (i=0;i<NOOFBLOCKS;i++)	// 16 block
		strcat(l,getStringFromArray(CHblock[i],COLQUANT));
	
	strcat(l,"\n");
	return l;
}
//---------------------------------------------------------------------
void CFrame::calculateCH(float * h,int x1, int x2, int y1, int y2)
{
	// USE Y, U, and V to calculate color histogram
	float temph[YCOLORRANGES][UCOLORRANGES][VCOLORRANGES];
	memset(temph,0,COLQUANT*4);
	for (int x = x1; x < x2 ;x++)
	{
		for (int y= y1; y < y2 ;y++)
		{
			temph[(int) Y[x][y]/(256/YCOLORRANGES)][(int) U[x/2][y/2]/(256/UCOLORRANGES)][(int) V[x/2][y/2]/(256/VCOLORRANGES)]++;
		}
	}

	memcpy(h,temph,COLQUANT*4);
	int M = (x2-x1)*(y2-y1);
	for (int j=0; j < COLQUANT; j++)
		h[j] = h[j]/(float) M;
}
//--------------------------------------------------------------------------
char * CFrame::getTT(float *h)
{
	const int NOOFBLOCKS=NOOFHBLOCKS*NOOFVBLOCKS;

	float TTA[NOOFBLOCKS], TTcont[NOOFBLOCKS];
	int i,j,b;
	char l[5000], temp[40];

	float M= (float) ((height * width) / NOOFBLOCKS);
	memset(TTA,0,NOOFBLOCKS*4);
	memset(TTcont,0,NOOFBLOCKS*4);

	// calculate color TTA for each block in the frame
	for(i=0;i<height;i++)
	{
		for	(j=0; j< width;j++)
		{
			b = (int) (i*4/height)*4 + (int) (j*4/width);
			TTA[b] += Y[i][j];
		}
	}

	for (i=0; i<NOOFBLOCKS; i++)
		TTA[i] = TTA[i]/(float)M;

	for (i=0;i<height;i++)
	{
		for (j=0;j<width;j++)
		{
			b = (int) (i*4/height)*4 + (int) (j*4/width);
			TTcont[b] += (float) ((Y[i][j]-TTA[b]) * (Y[i][j]-TTA[b]));
		}
	}

	strcpy(l,"");
	for (i=0; i< NOOFBLOCKS; i++)
	{
		TTcont[i] = TTcont[i]/(float) M;
		h[i*2] = TTA[i];
		h[i*2+1] = TTcont[i];

		if (!TTA[i] && !TTcont[i])
			strcat(l," 0 0");
		else 
		{
			if (!TTA[i])
				sprintf(temp," 0 %f",TTcont[i]);
			else if (!TTcont[i])
				sprintf(temp," %f 0",TTA[i]);
			else
				sprintf(temp," %f %f",TTA[i],TTcont[i]);
			strcat(l,temp);
		}
	}
	strcat(l,"\n");
	return l;
}
//-----------------------------------------------------------------------
char * CFrame::getTE(float *h)
{
	int HOE,VOE,NOE,SOE,T;// values for each pixel
	int f[256], YE[MImage_H][MImage_W], directions[MImage_H][MImage_W];		// array for YE frequencies
	int  i,j;
	float fDirection[TE_DIM];
	char l[2000];

	memset(f,0,256*4);
	memset(fDirection,0,TE_DIM*4);

	// consider only insider pixels
	for (i=1; i<height-1; i++)
	{
		for (j=1; j<width-1; j++)
		{
			// Insider pixel
			HOE = (Y[i-1][j-1] + 2 * Y[i-1][j] + Y[i-1][j+1] - (Y[i+1][j-1] + 2*Y[i+1][j] + Y[i+1][j+1]));
			YE[i][j] = getAbsolute(HOE);
			if (HOE > 0)
				directions[i][j] = 1;
			else
				directions[i][j] = 2;
	
			VOE = (Y[i-1][j-1] + 2*Y[i][j-1] + Y[i+1][j-1] - (Y[i-1][j+1] + 2*Y[i][j+1] + Y[i+1][j+1]));
			if (getAbsolute(VOE) > YE[i][j])
			{
				YE[i][j] = getAbsolute(VOE);
				if (VOE > 0)
					directions[i][j] = 3;
				else
					directions[i][j] = 4;
			}
	
			NOE = (2*Y[i-1][j-1] + Y[i-1][j] + Y[i][j-1] - (Y[i+1][j] + Y[i][j+1] + 2*Y[i+1][j+1]));
			if (getAbsolute(NOE) > YE[i][j])
			{
				YE[i][j] = getAbsolute(NOE);
				if (NOE > 0) 
					directions[i][j] = 5;
				else
					directions[i][j] = 6;
			}
	
			SOE = (Y[i-1][j] + 2*Y[i-1][j+1] + Y[i][j+1] - (Y[i][j-1] + 2*Y[i+1][j-1] + Y[i+1][j]));
			if (getAbsolute(SOE) > YE[i][j])
			{
				YE[i][j] = getAbsolute(SOE);
				if (SOE > 0)
					directions[i][j] = 7;
				else
					directions[i][j] = 8;
			}

			if (YE[i][j] > 255)
				f[255] ++;
			else
				f[YE[i][j]]++;
		}
	}

	// all the frame pixels are processed
	T = getThreshold(f,256,(height * width)-1);

	for (i=1; i<height - 1; i ++)
	{
		for (j=1; j<width - 1; j++)
		{
			if (YE[i][j] >= T)
			{
				fDirection[directions[i][j]]++;
			}
			else
			{
				fDirection[0]++;
			}	
		}
	}

	float M = (height - 2) * (width - 2);
	
	for (i=0; i< TE_DIM; i++)
		h[i] = (float) fDirection[i]/M;

	strcpy(l,getStringFromArray(h,TE_DIM));
	strcat(l,"\n");
	return l;
}
//-----------------------------------------------------------------

char * CFrame::getSCol(float *h2)
{
	int k,p,q,x;
	float h[COLQUANT], H[COLQUANT], v1,v2,v3;
	double pp;
	char l[1000], temp[50];

	if (!CHcalculated)
		calculateCH();

	memset(H,0,COLQUANT*4);
	for (k=0; k < COLQUANT; k++)
	{
		if (k>0)
		{
			p = (float)log(k)/(float)log(2);;
			q = k - pow(2,p) + 1;
			pp = pow(2,p);
			v1 = (float)(COLQUANT*(q-1))/pp;
			v2 = (float) COLQUANT*((float)q-0.5)/pp;
			v3 = (float) (COLQUANT*q)/pp;
		}
		for (x = 0; x < COLQUANT; x++)
		{
			if (!k)
				h[x] = 1/sqrtf(COLQUANT);
			else
			{
				if (x >= v1 && x <= v2)
					h[x] = pow(2,((float)p/2.0))/sqrtf(COLQUANT);
				else if (x > v2 && x<= v3)
					h[x] = -1 * pow(2,((float)p/2.0))/sqrtf(COLQUANT);
				else
					h[x] = 0;
			}

			H[k] += (CH[x] * h[x]);
		}
		H[k]/= sqrtf(COLQUANT);
		
		h2[k] = H[k];
	}
	strcpy(l,getStringFromArray(H,COLQUANT));
	strcat(l,"\n");
	return l;
}
//--------------------------------------------------------------------
char * CFrame::getHT(float *h)
{
	const int HTENERGY_DIM = HT_DIM -2;

	int i,j,k;
	float avg, std, energy[HTENERGY_DIM], M, temp;
	char l[1000];

	memset(energy,0,4*HTENERGY_DIM);
	avg=std=0;
	M = height * width;

	for (i=0; i<height; i++)
		for (j=0; j<width;j++)
			avg+= Y[i][j];
	avg /= M;
	h[0] = avg;

	for (i=0; i<height; i++)
		for (j=0; j<width;j++)
			std += (Y[i][j] - avg)*(Y[i][j]-avg);
	std /= M;
	h[1] =std;

	sprintf(l," %f %f",avg,std);
	temp = 256.0 / 30.0;
	for (k=0; k<HTENERGY_DIM; k++)
	{
		for (i=0; i<height; i++)
			for (j=0; j<width;j++)
				energy[k] += (Y[i][j] - temp * (float) k) * (Y[i][j] - temp * (float) k);
			
		energy[k] /= M;
		h[k+2] = energy[k];
	}
	strcat(l,getStringFromArray(energy,HTENERGY_DIM));
	strcat(l,"\n");
	return l;
}
//----------------------------------------------------------------------
char * CFrame::getEH(float *h)
{
	// the image is devided to 16-subimage inside each subimage 4*4 blocks
	// we detect the direction of each block. The output is for each subimage
	// the frequency of blocks in each direction (80 dimension)

	int HE,VE,E45,E135,T;// values for each pixel
	int f[256], YE[MImage_H][MImage_W], directions[MImage_H][MImage_W];		// array for YE frequencies
	float binCounts[EH_DIM];
	int  i,j, m,n;
	float fDirection[5];	// directions inside each block
	char l[2000];
	int const blockW = 4;
	int const blockH = 4;

	memset(f,0,256*4);
	memset(binCounts,0,EH_DIM*4);
	
	// consider only insider pixels
	for (i=1; i<height-1; i++)
	{
		for (j=1; j<width; j++)
		{
			// Insider pixel
			VE = (Y[i-1][j-1] + 2*Y[i][j-1] + Y[i+1][j-1] - (Y[i-1][j+1] + 2*Y[i][j+1] + Y[i+1][j+1]));
			YE[i][j] = getAbsolute(VE);
			directions[i][j] = 0;		// vertical

			HE = (Y[i-1][j-1] + 2 * Y[i-1][j] + Y[i-1][j+1] - (Y[i+1][j-1] + 2*Y[i+1][j] + Y[i+1][j+1]));
			if (getAbsolute(HE) > YE[i][j])
			{
				YE[i][j] = getAbsolute(HE);
				directions[i][j] = 1; //horizontal
			}

			E45 = (2*Y[i-1][j-1] + Y[i-1][j] + Y[i][j-1] - (Y[i+1][j] + Y[i][j+1] + 2*Y[i+1][j+1]));
			if (getAbsolute(E45) > YE[i][j])
			{
				YE[i][j] = getAbsolute(E45);
				directions[i][j] = 2;		// 45 edge
			}
	
			E135 = (Y[i-1][j] + 2*Y[i-1][j+1] + Y[i][j+1] - (Y[i][j-1] + 2*Y[i+1][j-1] + Y[i+1][j]));
			if (getAbsolute(E135) > YE[i][j])
			{
				YE[i][j] = getAbsolute(E135);
				directions[i][j] = 3;	// 135 edge
			}

			if (YE[i][j] > 255)
				f[255] ++;
			else
				f[YE[i][j]]++;
		}
	}

	// all the frame pixels are processed
	T = getThreshold(f,256,(height * width)-1);

	for (i=1; i<height - 1; i ++)
	{
		for (j=1; j<width - 1; j++)
		{
			if (YE[i][j] < T)
				directions[i][j] = 4;	// non edge
		}
	}

	for(n=0; n <height/blockH; n++)
		for (m=0; m<width/blockW;m++)
		{
			memset(fDirection,0,5*4);
			for (i=0; i< blockH; i++)
				for (j=0; j<blockW; j++)
				{
					int x = n*blockH + i;
					int y = m*blockW + j;

					if (x == 0 || x == height-1 || y==0 || y==width - 1)
						continue;
					else
						fDirection[directions[x][y]] ++;
				}

				// get the block direction by specifying the max pixels that has this direction
				int blockDirection = 0;
				for (i=1; i<5; i++)
					if (fDirection[i] > fDirection[i-1])
						blockDirection = i;

				i = m * 4 * blockW / width;	//index of subimage in x direction
				j = n * 4 * blockH / height;	//index of subimage in y direction

				// map the block index and diection to the one dimension array
				binCounts[(j*4+i)*5 + blockDirection]++;
		}

	float M = height * width / (4*4*blockH*blockW);	// number of blocks per subimage

	strcpy(l,"");
	for (i=0; i< EH_DIM; i++)
		h[i] = binCounts[i]/M;

	strcpy(l,getStringFromArray(h,EH_DIM));
	strcat(l,"\n");
	return l;
}
//----------------------------------------------------------------
char * getDCFromCH(float *ch)
{
	// this gets the dominant color in the array given in the argument
	// and return the set of dominant colors in the string
	int dc[COLQUANT],i,j;	// dc holds the indexes of the dominant colors
	float h[COLQUANT], CHDC[COLQUANT];

	memcpy(h,ch,COLQUANT*4);
	memset(CHDC,0,COLQUANT*4);

	for (i=0; i<COLQUANT; i++) 
		dc[i] = i;

	for (i =0; i<NOOFDOMINANTCOLORS; i++)
	{
		for (j=i+1; j< COLQUANT; j++)
		{
			if (h[i] < h[j])
			{
				// swap h[i], h[j]
				float x = h[i];
				h[i] = h[j];
				h[j] = x;

				x = dc[i];
				dc[i] = dc[j];
				dc[j] = x;
			}
		}
		CHDC[dc[i]] = h[i];
		/*		
		Originally the output was 8 dimensions with the YUV component values
		int y,u,v;	// the indices for YUV 
		y = (dc[i]/(UCOLORRANGES * VCOLORRANGES));
		u = (dc[i]%(UCOLORRANGES * VCOLORRANGES))/VCOLORRANGES;
		v = (dc[i]%(UCOLORRANGES * VCOLORRANGES))%VCOLORRANGES;

		if (!h[i])
			sprintf(temp, " 0 %d %d %d",y,u,v);
		else
			sprintf(temp, " %f %d %d %d",h[i],y,u,v);
		strcat(s,temp);
		*/
		// The output now will be in 32 dimensions like the color histogram
		// with the percentages of the dominant colors in the positions of 
		// the dominant colors and zeros else where
		// Now i is a dominant color
	}
	return (getStringFromArray(CHDC,COLQUANT));
}
//-----------------------------------------------------------------
void CFrame::calculateCHD()
{
	if (!CHcalculated)
		calculateCH();

	if (!ref->CHcalculated)
		ref->calculateCH();

	for (int i=0; i < COLQUANT; i++)
		if (CH[i] + ref->CH[i])
			HD += ((CH[i]-ref->CH[i])*(CH[i]-ref->CH[i])) / ((CH[i]+ref->CH[i])*(CH[i]+ref->CH[i]));
}
