// Frame.h: interface for the CFrame class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FRAME_H__53BD490D_146A_4288_B75B_965E8F98933C__INCLUDED_)
#define AFX_FRAME_H__53BD490D_146A_4288_B75B_965E8F98933C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Global.h"
#include "Block4.h"
#include "Block8.h"
char * getDCFromCH(float *ch);

class CFrame  
{
public:
	int getFrameId() {return id;};
	
	char * getCH(float *h);
	char * getCM(float *h);
	char * getDC();
	char * getCHHSV(float *h);
	char * getTE(float *h);
	char * getTT(float *h);
	char * getCL(float *h);
	char * getSCol(float *h);
	char * getEH(float *h);
	char * getHT(float *h);

private:
	int height;
	int width;
	bool CHcalculated;
	float CH [COLQUANT];

	void calculateCH();
	void calculateCH(float *h,int x1,int x2,int y1,int y2);

public:
	void calculateCHD();
	int id;	// video id starts from 0

	void copyFrame(CFrame *newFrame);
	float LCONThreshold;	// spatial segmenation threshold
	float FCONThreshold;	// temporal segmentation threshold
	CFrame * ref;
	float HD;
	BYTE **Y;
	BYTE **U;
	BYTE **V;
	CBlock4* block4[MImage_H/4][MImage_W/4];	// block size 4*4
	CBlock8* block8[MImage_H/8][MImage_W/8];	// block size 8*8

	void temporalSegmentation();
	void spatialSegmentation();
	void setBlockDirection(int i, int j);	
	float getDifference(int m, int n, int blockSize, int stepx, int stepy);
	void motionEstimation();
	void estimateBlockMotion(int i, int j);
	void readFrame(CFile*& f, int &eof);
	void calculateColorHD();
	CFrame();
	CFrame(int frameId, int frameH, int frameW);
	virtual ~CFrame();

};

#endif // !defined(AFX_FRAME_H__53BD490D_146A_4288_B75B_965E8F98933C__INCLUDED_)
