// for the MPEG Decoder
#include "lib\cmpvdeco.h"
#include "lib\cobfBuf.h"

#define MImage_W 352
#define MImage_H 240
//#define MImage_W  176
//#define MImage_H 144
#define MCHUNCK 500		// the maximum chunckSize

// the block motion directions
#define STATIONARY 0
#define RIGHT 1
#define RIGHTUP 2
#define UP 3
#define LEFTUP 4
#define LEFT 5
#define LEFTDOWN 6
#define DOWN 7
#define RIGHTDOWN 8

// infinity value (very large value)
#define INF 9999999

// indeces of output files
#define SCFILE 0	// scene cuts
#define	SSFILE 1	// sptial segmentation
#define	TSFILE 2	// temporal segmentation
#define	MVFILE 3	// motion vectors
#define	SEFILE 4	// special effects
#define	KFFILE 5	// key frames
#define CHFILE 6	// Color Histogram
#define CMFILE 7	// color moment
#define CLFILE 8	// color layout
#define MHFILE 9	// motion histogram
#define TTFILE 10	// texture tamura
#define TEFILE 11	// texture edges
#define CHHSVFILE 12// Color histogram HSV format
#define CHFFILE 13	// Color Histogram / frame
#define CMFFILE 14	// color moment 
#define CLFFILE 15	// color layout
#define MHFFILE 16	// motion histogram
#define TTFFILE 17	// texture tamura
#define TEFFILE 18	// texture edges
#define CHHSVFFILE 19// color histogram HSV
#define KFDATFILE 20	// the data file of the key frames
#define VSDATFILE 21	// the data file of the video shots
#define VSOFFDATFILE 22	// the data file of the video shots offsets
#define DCFILE 23	// dominant color
#define DCFFILE 24	// dominant color per frame
#define SCOLFILE 25	// Scalable Color
#define SCOLFFILE 26	// Scalable Color per frame
#define HTFILE 27		// Homogeneous Texture
#define HTFFILE 28		// homogenous texture per frame
#define EHFILE 29		// Edge Histogram
#define EHFFILE 30		// Edge Histogram per frame
#define NOOFFILES 31

// CONSTANTS FOR THE FEATURE EXTRACTION
#define YCOLORRANGES 8		// YUV color quantization = 32 (8*2*2)
#define UCOLORRANGES 2
#define VCOLORRANGES 2
#define COLQUANT YCOLORRANGES*UCOLORRANGES*VCOLORRANGES
#define NOOFDOMINANTCOLORS 8
#define HT_DIM 32	// homogeneous texture dimension (avg,stdv, 30 level of energy)
#define EH_DIM 80	// edge histogram dimension
#define HSV_DIM 256 //HScale * SScale * VScale should be changed if this changed
#define CM_DIM 2	// color moment dimension is the mean and variance
#define NOOFHBLOCKS 4		// the number of horizontal blocks used for calculating CL, TT
#define NOOFVBLOCKS 4		// the number of vertical blocks used for calculating CL, TT
#define CL_DIM NOOFHBLOCKS*NOOFVBLOCKS*	COLQUANT	// the Color layout dimension
#define TT_DIM NOOFHBLOCKS*NOOFVBLOCKS*2	// mean and variance for total number of blocks
#define TE_DIM 9

// The value read from the input form
extern int g_Image_H;
extern int g_Image_W;
extern int g_noFrames;
extern BOOL	g_sceneCuts;
extern BOOL	g_keyFrames;
extern BOOL	g_spatialSeg;
extern BOOL	g_specialEffects;
extern BOOL	g_temporalSeg;
extern BOOL g_features;
extern BOOL	g_CH, g_CH2, g_CM, g_CL, g_TT, g_TE, g_MH, g_DC, g_SC, g_HT, g_EH;
extern CFile* g_outputFiles[NOOFFILES];
extern CString g_metadataFile;

// The number of frames to be read in each read
extern int g_chunckSize;

// the number of frames to be displayed in a row
extern int g_noFramesInRow;

// the id of the coming frame that should be saved to the file system initially -1
extern int g_shotNo;
extern int g_shotEnd;
extern int g_shotStart;
extern int g_videoId;
//extern long g_lastSceneCutOffset;
//extern long g_curSceneCutOffset;
//extern long g_lastSceneCutOffset2;
//extern long g_lastIFrameOffset;

// for MPEG decoding
extern CMpvDecoder MpvDecoder;
extern BYTE *pnOutBuf;
extern const HEADERDATA *pHeaderData;

int getThreshold(int *f, int maxSize,float initialP1);
float getAbsolute(float x);
int *calculateFrequencies(float * x, int xSize, int start, int fSize, int mapping, float maxValue);
int getMin(float *f, int fSize);
COLORREF YUVToRGB(BYTE y, BYTE  u, BYTE v);
void constructOutputFiles(CString fileName);
CString constructFileName(CString originalName, CString addPart);
class CFrame;
void YUV2R_G_B(CFrame *crtFrame,unsigned char *r, unsigned char *g, unsigned char *b);
int getRandomNumber(int min, int max);
int between(double n, double x, double y);
void updateShotStatistics(float *avgArr, float *minArr, float *h, int dim);
void updateShotStatistics(float *avgArr, float *h, int dim);
char * getStringFromArray(float *h, int dim);