// InputForm.cpp : implementation file
//

#include "stdafx.h"
#include "VideoDB.h"
#include "InputForm.h"

#include "MyScrollView.h"
#include "video.h"
#include "VideoDBDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInputForm

IMPLEMENT_DYNCREATE(CInputForm, CFormView)

CInputForm::CInputForm()
	: CFormView(CInputForm::IDD)
{
	//{{AFX_DATA_INIT(CInputForm)
	m_sceneCuts = TRUE;
	m_keyFrames = TRUE;
	m_spatialSeg = FALSE;
	m_specialEffects = FALSE;
	m_temporalSeg = FALSE;
	m_noFrames = 100;
	m_features = FALSE;
	m_chunckSize = 20;
	m_metadataFile = _T("");
	m_videoId = 1;
	m_CH = FALSE;
	m_CH2 = FALSE;
	m_CM = FALSE;
	m_TE = FALSE;
	m_TT = FALSE;
	m_CL = FALSE;
	m_MH = FALSE;
	m_DC = FALSE;
	m_SC = FALSE;
	m_HT = FALSE;
	m_EH = FALSE;
	//}}AFX_DATA_INIT
}

CInputForm::~CInputForm()
{
}

void CInputForm::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInputForm)
	DDX_Check(pDX, IDC_sceneCuts, m_sceneCuts);
	DDX_Check(pDX, IDC_keyFrames, m_keyFrames);
	DDX_Check(pDX, IDC_spatialSeg, m_spatialSeg);
	DDX_Check(pDX, IDC_specialEffects, m_specialEffects);
	DDX_Check(pDX, IDC_temporalSeg, m_temporalSeg);
	DDX_Text(pDX, IDC_noFrames, m_noFrames);
	DDX_Check(pDX, IDC_features, m_features);
	DDX_Text(pDX, IDC_chunckSize, m_chunckSize);
	DDV_MinMaxInt(pDX, m_chunckSize, 5, 500);
	DDX_Text(pDX, IDC_metadaFile, m_metadataFile);
	DDX_Text(pDX, IDC_videoId, m_videoId);
	DDX_Check(pDX, IDC_CH, m_CH);
	DDX_Check(pDX, IDC_CH2, m_CH2);
	DDX_Check(pDX, IDC_CM, m_CM);
	DDX_Check(pDX, IDC_TE, m_TE);
	DDX_Check(pDX, IDC_TT, m_TT);
	DDX_Check(pDX, IDC_CL, m_CL);
	DDX_Check(pDX, IDC_MH, m_MH);
	DDX_Check(pDX, IDC_DC, m_DC);
	DDX_Check(pDX, IDC_SC, m_SC);
	DDX_Check(pDX, IDC_HT, m_HT);
	DDX_Check(pDX, IDC_EH, m_EH);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInputForm, CFormView)
	//{{AFX_MSG_MAP(CInputForm)
	ON_BN_CLICKED(IDC_run, Onrun)
	ON_BN_CLICKED(IDC_close, Onclose)
	ON_BN_CLICKED(IDC_clear, Onclear)
	ON_BN_CLICKED(IDC_metadataFile, OnmetadataFile)
	ON_BN_CLICKED(IDC_features, Onfeatures)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInputForm diagnostics

#ifdef _DEBUG
void CInputForm::AssertValid() const
{
	CFormView::AssertValid();
}

void CInputForm::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CInputForm message handlers

void CInputForm::Onrun() 
{
	// TODO: Add your control notification handler code here

	GetDlgItem(IDC_run)->EnableWindow(FALSE);	// disable run button

	// Get pointers to the view in the lower panes
	CSplitterWnd *parent;	
	CMyScrollView *downV;

	parent = (CSplitterWnd *) GetParent();	// the first level splitter window
	downV = (CMyScrollView*) parent->GetPane(1,0);

	// Get the values from the input form and put in global variables.
	UpdateData(TRUE);
	g_Image_H = 0;
	g_Image_W = 0;
	g_keyFrames = m_keyFrames;
	g_noFrames = m_noFrames;
	g_sceneCuts = m_sceneCuts;
	g_specialEffects = m_specialEffects;
	g_spatialSeg = m_spatialSeg;
	g_temporalSeg = m_temporalSeg;
	g_chunckSize = m_chunckSize;
	g_noFramesInRow = 2;
	g_metadataFile = m_metadataFile;
	g_videoId = m_videoId;
	g_CH = m_CH;
	g_CH2 = m_CH2;
	g_CM = m_CM;
	g_CL = m_CL;
	g_TT = m_TT;
	g_TE = m_TE;
	g_MH = m_MH;
	g_DC = m_DC;
	g_SC = m_SC;
	g_HT = m_HT;
	g_EH = m_EH;
	g_features = g_CH || g_CH2 || g_CM || g_CL || g_TT || g_TE || g_MH || g_DC || g_SC || g_HT || g_EH;

	// work the loaded document
	CVideo *video;
	CVideoDBDoc *doc;

	doc = (CVideoDBDoc*) GetDocument();
	video = doc->video;
	video->processVideo(downV);

	GetDlgItem(IDC_clear)->EnableWindow(TRUE);	// enable clear button

	strcpy(downV->l,"FINISH...");
	downV->Invalidate();
	downV->UpdateWindow();
}
//----------------------------------------------------------------
void CInputForm::Onclose() 
{
	// TODO: Add your control notification handler code here
	_exit(1);	
}
//-----------------------------------------------------------------
void CInputForm::Onclear() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_clear)->EnableWindow(FALSE);	// disable clear button

	CVideo * v = ((CVideoDBDoc*) GetDocument())->video ;
	v->clearVideo();

		// Get pointers to the view in the lower pane
	CSplitterWnd *parent;	
	CMyScrollView *downV;

	parent = (CSplitterWnd *) GetParent();	// the first level splitter window
	downV = (CMyScrollView*) parent->GetPane(0,1);	// the down view

	strcpy(downV->l,"");
	downV->Invalidate();

	GetDlgItem(IDC_run)->EnableWindow(TRUE);	// enable the run button
}
//---------------------------------------------------
void CInputForm::OnmetadataFile() 
{
	// TODO: Add your control notification handler code here
		// work the loaded document
	CVideo *video;
	CVideoDBDoc *doc;

	doc = (CVideoDBDoc*) GetDocument();
	video = doc->video;

	UpdateData(TRUE);
	m_metadataFile = constructFileName(video->openedFile->GetFilePath(),"");

	UpdateData(FALSE);	// data initialized not retrieved
	UpdateWindow();
}
//-----------------------------------------------------
void CInputForm::Onfeatures() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (!m_features)
	{
		m_CH = FALSE;
		m_CH2 = FALSE;
		m_CM = FALSE;
		m_CL = FALSE;
		m_TT = FALSE;
		m_TE = FALSE;
		m_MH = FALSE;
		m_DC = FALSE;
		m_EH = FALSE;
		m_HT = FALSE;
		m_SC = FALSE;
	}
	else
	{
		m_CH = TRUE;
		m_CH2 = TRUE;
		m_CM = TRUE;
		m_CL = TRUE;
		m_TT = TRUE;
		m_TE = TRUE;
		m_MH = TRUE;
		m_DC = TRUE;
		m_EH = TRUE;
		m_HT = TRUE;
		m_SC = TRUE;
	}
	UpdateData(FALSE);
	UpdateWindow();

}
