// TLowPass.cpp: implementation of the TLowPass class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TLowPass.h"
#include "assert.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TLowPass::TLowPass()
{
	bIsThisClassInit=false;
}

TLowPass::~TLowPass()
{
	if(bIsThisClassInit)
	{
	delete(BmpBuffer);
	}

}
//--------------------------
//-----------------------------
void TLowPass::InitLowPass(int w,int h)
{
 BmpBuffer=new unsigned char[w*h];
 assert(BmpBuffer!=NULL);
 memset(BmpBuffer,0,w*h);
 LModel[0][0]=LModel[0][2]=LModel[2][0]=LModel[2][2]=1;
 LModel[0][1]=LModel[1][0]=LModel[2][1]=LModel[1][2]=1;
 LModel[1][1]=1;
 wide=w;
 height=h;
 bIsThisClassInit=true;
}
//-----------------------------------------
TLowPass::TLowPass(int w,int h)
{
 BmpBuffer=new unsigned char[w*h];
 assert(BmpBuffer!=NULL);
 memset(BmpBuffer,0,w*h);
 LModel[0][0]=LModel[0][2]=LModel[2][0]=LModel[2][2]=1;
 LModel[0][1]=LModel[1][0]=LModel[2][1]=LModel[1][2]=1;
 LModel[1][1]=1;
 wide=w;
 height=h;
}
//--------------------------
void TLowPass::DoLowPass(unsigned char *Input,unsigned char *Output)
{
int tempx;
memset(BmpBuffer,0,height*wide);
for(int i=1;i<height-1;i++)
 {
  for(int j=1;j<wide-1;j++)
   {
    tempx=0;
    for(int k=0;k<3;k++)
     {
      for(int l=0;l<3;l++)
       {
        tempx=tempx+((int)Input[(i+k-1)*wide+j+l-1])*LModel[k][l];
       }
     }
    BmpBuffer[i*wide+j]=tempx/9;
   }
 }
memset(Input,0,height*wide);
memcpy(Output,BmpBuffer,height*wide);
}
//-----------------------------------------------------