// TMotionVector.cpp: implementation of the TMotionVector class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TMotionVector.h"
#include "math.h"
#include "assert.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



//-------------------------------------------------------------
//----------------------------------------------------------------------
TMotionVector::TMotionVector()
{
bIsThisClassInit=false;
}
//------------------------------------------------------------------------
//
TMotionVector::InitMotionVector(int w,int h,int Dim,int Dis,int x,int y,int Numx,int Numy,int BlcD)
{
for(int i=0;i<Numx*Numy;i++)
 {BaseBuffer[i]=new unsigned char[Dim*Dim];
  assert(BaseBuffer[i]!=NULL);
//  memset(BaseBuffer[i],0,Numx*Numy);
 }
ShotFrameType=new unsigned char[10000];
XStart=x;YStart=y;
VecNumberx=Numx;
VecNumbery=Numy;
BDistance=BlcD;
BmpBuffer=new unsigned char[w*h];
assert(BmpBuffer!=NULL);
memset(BmpBuffer,0,w*h);
height=h;
wide=w;
Dimension=Dim;
Distance=Dis;
OneBlockM=(2*Distance+1)*(2*Distance+1);
XSLocation=new int[Numx*Numy];
assert(XSLocation!=NULL);
memset(XSLocation,0,4*Numx*Numy);
XELocation=new int[Numx*Numy];
assert(XELocation!=NULL);
memset(XELocation,0,4*Numx*Numy);
YSLocation=new int[Numx*Numy];
assert(YSLocation!=NULL);
memset(YSLocation,0,4*Numx*Numy);
YELocation=new int[Numx*Numy];
assert(YELocation!=NULL);
memset(YELocation,0,4*Numx*Numy);
XPoints=new int[OneBlockM];
assert(XPoints!=NULL);
memset(XPoints,0,4*OneBlockM);
YPoints=new int[OneBlockM];
assert(YPoints!=NULL);
memset(YPoints,0,4*OneBlockM);
PPointVector=new int[OneBlockM];
assert(PPointVector!=NULL);
memset(PPointVector,0,4*OneBlockM);
bIsThisClassInit=true;
}
//------------------------------------------------------------------------
//
TMotionVector::TMotionVector(int w,int h,int Dim,int Dis,int x,int y,int Numx,int Numy,int BlcD)
{
for(int i=0;i<Numx*Numy;i++)
 {BaseBuffer[i]=new unsigned char[Dim*Dim];
  assert(BaseBuffer[i]!=NULL);
//  memset(BaseBuffer[i],0,Numx*Numy);
 }
ShotFrameType=new unsigned char[10000];
XStart=x;YStart=y;
VecNumberx=Numx;
VecNumbery=Numy;
BDistance=BlcD;
BmpBuffer=new unsigned char[w*h];
assert(BmpBuffer!=NULL);
memset(BmpBuffer,0,w*h);
height=h;
wide=w;
Dimension=Dim;
Distance=Dis;
OneBlockM=(2*Distance+1)*(2*Distance+1);
XSLocation=new int[Numx*Numy];
assert(XSLocation!=NULL);
memset(XSLocation,0,4*Numx*Numy);
XELocation=new int[Numx*Numy];
assert(XELocation!=NULL);
memset(XELocation,0,4*Numx*Numy);
YSLocation=new int[Numx*Numy];
assert(YSLocation!=NULL);
memset(YSLocation,0,4*Numx*Numy);
YELocation=new int[Numx*Numy];
assert(YELocation!=NULL);
memset(YELocation,0,4*Numx*Numy);
XPoints=new int[OneBlockM];
assert(XPoints!=NULL);
memset(XPoints,0,4*OneBlockM);
YPoints=new int[OneBlockM];
assert(YPoints!=NULL);
memset(YPoints,0,4*OneBlockM);
PPointVector=new int[OneBlockM];
assert(PPointVector!=NULL);
memset(PPointVector,0,4*OneBlockM);
}
//-------------------------------------------------------------------
TMotionVector::~TMotionVector()
{
if(bIsThisClassInit)
{
 delete(BmpBuffer);
 delete(XPoints);
 delete(YPoints);
 delete(PPointVector);
 delete(ShotFrameType);
 delete(XSLocation);
 delete(XELocation);
 delete(YSLocation);
 if(YELocation)
   delete(YELocation);

 for(int i=0;i<VecNumberx*VecNumbery;i++)
  {
   delete(BaseBuffer[i]);
  }
 bIsThisClassInit=false;
}
}
//------------------------------------------------------------------
int TMotionVector::GetCurrentMotionBase(unsigned char *Input)
{
if((XStart<Distance)||(YStart<Distance))
  {return(-1);
  }
if((XStart+(VecNumberx-1)*BDistance+Distance)>wide)
  {return(-1);
  }
if((YStart+(VecNumbery-1)*BDistance+Distance)>height)
  {return(-1);
  }
for(int i=0;i<VecNumbery;i++)
 {
  for(int j=0;j<VecNumberx;j++)
   {
    for(int k=0;k<Dimension;k++)
      {
       for(int l=0;l<Dimension;l++)
        {
         //BaseBuffer[k*Dimension+l]=Input[(y+k)*wide+x+l];
         BaseBuffer[i*VecNumberx+j][k*Dimension+l]=Input[(YStart+i*BDistance+k)*wide+XStart+j*BDistance+l];
        }
      }

   }
 }
return(1);
}
//-------------------------------------------------------------------
int TMotionVector::GetMotionVectorColl(unsigned char *Input,int HNumber,int x,int y)
{
int temp=0;
if((x>wide)||(y>height))
  {return(-1);
  }
if(((x)<0)||((y)<0))
  {return(-1);
  }
for(int i=0;i<Dimension;i++)
  {
   for(int j=0;j<Dimension;j++)
    {
    temp=temp+abs(Input[(y+i)*wide+x+j]-BaseBuffer[HNumber][i*Dimension+j]);//pow((Input[(x+i)*wide+y+j]-BaseBuffer[i*Dimension+j]),2);
    }
  }
return(temp);
}
//----------------------------------------------------------------------
int TMotionVector::GetXYPoints(int X,int Y,unsigned char *Input)
{
int temp=0;
int tempx,tempy;
int jTempCacu;
jTempCacu=0;
if(((X+Distance)>wide)||((Y+Distance)>height))
  {return(-1);
  }
if(((X-Distance)<0)||((Y-Distance)<0))
  {return(-1);
  }
tempx=X-Distance;
tempy=Y-Distance;
for(int i=0;i<=2*Distance;i++)
  { for(int j=0;j<=2*Distance;j++)
     {
     XPoints[jTempCacu]=tempx+j;
     YPoints[jTempCacu]=tempy+i;
     jTempCacu++;
     }
  }
return(1);
}
//----------------------------------------------------------------------
int TMotionVector::GetXYPointsFast(int X,int Y,unsigned char *Input)
{
int temp=0;
int tempx,tempy;
int jTempCacu;
jTempCacu=0;
if(((X+Distance)>wide)||((Y+Distance)>height))
  {return(-1);
  }
if(((X-Distance)<0)||((Y-Distance)<0))
  {return(-1);
  }
tempx=X-Distance;
tempy=Y-Distance;
for(int i=0;i<2*Distance;i=i+4)
  { for(int j=0;j<2*Distance;j=j+4)
     {
     XPoints[jTempCacu]=tempx+j;
     YPoints[jTempCacu]=tempy+i;
     jTempCacu++;
     }
  }
return(1);
}

//----------------------------------------------------------------------
int TMotionVector::GetXYPointsSecondStep(int X,int Y,unsigned char *Input)
{
int temp=0;
int jTempCacu;
jTempCacu=0;
for(int i=0;i<4;i++)
  { for(int j=0;j<4;j++)
     {
     XPoints[jTempCacu]=X+j;
     YPoints[jTempCacu]=Y+i;
     jTempCacu++;
     }
  }
return(1);
}
//---------------------------------------------------------------------
int TMotionVector::MinArryInt(int *Input,int Number,int TNumber)
{
int tempx;
int tempLocation;
tempLocation=0;
tempx=Input[0];
for(int i=0;i<Number;i++)
 {if(Input[i]<=tempx)
   { tempx=Input[i];
     tempLocation=i;
    }
 }
XELocation[TNumber]=XPoints[tempLocation];
YELocation[TNumber]=YPoints[tempLocation];
return(tempx);
}

//----------------------------------------------------------------------
int TMotionVector::CaculateMotionVector(unsigned char *Input,int Number)
{
int tempCacu;
tempCacu=0;
//GetCurrentMotionBase(Input,X,Y);
if(GetXYPointsFast(XSLocation[Number],YSLocation[Number],Input)==-1)
 {
  
	MessageBox(NULL,"Edge Overflow while get the motion vector base.","Error!",MB_OK);
	exit(0);
 }
//for(int i=0;i<OneBlockM;i++)
for(int i=0;i<64;i++)
{
if(( PPointVector[i]=GetMotionVectorColl(Input,Number,XPoints[i],YPoints[i]))==-1)
  {
	PPointVector[i]=0;
	MessageBox(NULL,"Error While Getting the Motion Vector.","Error!",MB_OK);
	exit(0);
  }
}
//MinArryInt(PPointVector,OneBlockM,Number);
MinArryInt(PPointVector,64,Number);

GetXYPointsSecondStep(XELocation[Number],YELocation[Number],Input);
for(i=0;i<16;i++)
{
if(( PPointVector[i]=GetMotionVectorColl(Input,Number,XPoints[i],YPoints[i]))==-1)
  {
	PPointVector[i]=0;
	MessageBox(NULL,"Error While Getting the Motion Vector.","Error!",MB_OK);
	exit(0);
  }
}
MinArryInt(PPointVector,16,Number);

return(0);
}
//----------------------------------------------------------------------
//----------------------------------------------------------------------
int TMotionVector::CaculateWholeMotionVector(unsigned char *Input)
{
GlobalCaculater=0;
if((XStart<Distance)||(YStart<Distance))
  {return(-1);
  }
if((XStart+(VecNumberx-1)*BDistance+Distance)>wide)
  {return(-1);
  }
if((YStart+(VecNumbery-1)*BDistance+Distance)>height)
  {return(-1);
  }
for(int i=0;i<VecNumbery;i++)
 {
  for(int j=0;j<VecNumberx;j++)
   {
    XSLocation[i*VecNumberx+j]=XStart+j*BDistance;
    YSLocation[i*VecNumberx+j]=YStart+i*BDistance;
    CaculateMotionVector(Input,(i*VecNumberx+j));
   }
 }
return(1);

}
//---------------------------------------------------------------------------
int TMotionVector::FastCaculateMotionVectorStepOne(unsigned char *Input)
{
if((XStart<Distance)||(YStart<Distance))
  {return(-1);
  }
if((XStart+(VecNumberx-1)*BDistance+Distance)>wide)
  {return(-1);
  }
if((YStart+(VecNumbery-1)*BDistance+Distance)>height)
  {return(-1);
  }
for(int i=0;i<VecNumbery;i++)
 {
  for(int j=0;j<VecNumberx;j++)
   {
    XSLocation[i*VecNumberx+j]=XStart+j*BDistance;
    YSLocation[i*VecNumberx+j]=YStart+i*BDistance;
    CaculateMotionVector(Input,(i*VecNumberx+j));
   }
 }
return(1);
}

//----------------------------------------------------------------------
int TMotionVector::HoughTransfer(int ErrorDegree, int *DirectHist)
{
int HHistogram[360];
int *TempHist;
int iDegree;
float iDegree1;
float fDirection[4];
FalseNumber=0;
TempHist=new int[VecNumberx*VecNumbery];
iDegree=0;
iDegree1=0.0;
memset(MDirection,0,16);
memset(HHistogram,0,360*4);
memset(TempHist,0,4*VecNumberx*VecNumbery);
for(int i=0;i<VecNumberx*VecNumbery;i++)
 {

  iDegree=0;
  iDegree1=0;
  if((XELocation[i]-XSLocation[i])==0)
   {
     if((YELocation[i]-YSLocation[i])==0)
       {iDegree=0;
       }
     else if((YELocation[i]-YSLocation[i])>0)
       {iDegree=270;
       }
     else
       {iDegree=90;
       }
   }
  else if((YELocation[i]-YSLocation[i])==0)
   {
     if((XELocation[i]-XSLocation[i])==0)
       {iDegree=0;
       }
     else if((XELocation[i]-XSLocation[i])>0)
       {iDegree=0;
       }
     else
       {iDegree=180;
       }
   }
  else
   {
     iDegree1=(float)atan(fabs(float(YELocation[i]-YSLocation[i])/float(XELocation[i]-XSLocation[i])));
     iDegree1=(float)(iDegree1*57.29578);
     if(((YELocation[i]-YSLocation[i])>0)&&((XELocation[i]-XSLocation[i])>0))
        {iDegree=360-(int)iDegree1;
        }
     else if(((YELocation[i]-YSLocation[i])>0)&&((XELocation[i]-XSLocation[i])<0))
        {iDegree=180+(int)iDegree1;
        }
     else if(((YELocation[i]-YSLocation[i])<0)&&((XELocation[i]-XSLocation[i])<0))
        {iDegree=180-(int)iDegree1;
        }
     else if(((YELocation[i]-YSLocation[i])<0)&&((XELocation[i]-XSLocation[i])>0))
        {iDegree=(int)iDegree1;
        }

   }
 TempHist[i]=iDegree;
 HHistogram[iDegree]++;
 DirectHist[iDegree++];
 }
int temp1,tempLL;
temp1=HHistogram[0];
tempL=0;
for(i=1;i<360;i++)
 {
  if(HHistogram[i]>temp1)
   { temp1=HHistogram[i];
     tempL=i;
   }
 }
//----------

int jStillNumber;
jStillNumber=0;
for(i=0;i<VecNumberx*VecNumbery;i++)
 {
  if((abs(YELocation[i]-YSLocation[i])+abs(XELocation[i]-XSLocation[i]))<=1)
   { XELocation[i]=XSLocation[i];
     YELocation[i]=YSLocation[i];
     TempHist[i]=-1;
     jStillNumber++;
   }
 }
if(jStillNumber>=(VecNumberx*VecNumbery/2))
 {
  return(STILL);
 }
if(ErraseIrregularPoint(TempHist)==-1)
 {
  return(IRREGULAR);
 }
//return(0);

int xAverage[4],yAverage[4];
xAverage[0]=yAverage[0]=0;
xAverage[1]=yAverage[1]=0;
xAverage[2]=yAverage[2]=0;
xAverage[3]=yAverage[3]=0;
for(i=0;i<VecNumberx*VecNumbery;i++)
 {
  if(TempHist[i]!=-1)
  {
   if((abs(TempHist[i]-tempL)<45)||(abs(TempHist[i]-tempL)>=314))
     {
     xAverage[0]=xAverage[0]+XSLocation[i];
     yAverage[0]=yAverage[0]+YSLocation[i];
     MDirection[0]++;
     }
  }
 }
if(MDirection[0]==0)
 {MDirection[0]=1;
 }
xAverage[0]=xAverage[0]/MDirection[0];
yAverage[0]=yAverage[0]/MDirection[0];


if(MDirection[0]<VecNumberx*VecNumbery*4/5)
 {
 }
else
 {if((tempL>135)&&(tempL<225))
   {
    return(PAN_RIGHT);
   }
  else if((tempL>314)||(tempL<45))
   {
    return(PAN_LEFT);
   }
  else if((tempL>45)&&(tempL<135))
   {
    return(TILT_DOWN);
   }
  else if((tempL>225)&&(tempL<315))
   {
    return(TILT_UP);
   }
  return(0);
 }
tempLL=(tempL+90)%360;
fDirection[0]=(float)tempL;
fDirection[1]=(float)tempLL;
for(i=0;i<VecNumberx*VecNumbery;i++)
 {
  if(TempHist[i]!=-1)
   {
    if((abs(TempHist[i]-tempLL)<45)||(abs(TempHist[i]-tempLL)>=314))
     {
     xAverage[1]=xAverage[1]+XSLocation[i];
     yAverage[1]=yAverage[1]+YSLocation[i];
     MDirection[1]++;
     }
   }
 }
if(MDirection[1]==0)
 {MDirection[1]=1;
 }
xAverage[1]=xAverage[1]/MDirection[1];
yAverage[1]=yAverage[1]/MDirection[1];
tempLL=(tempLL+90)%360;
fDirection[2]=(float)tempLL;
for(i=0;i<VecNumberx*VecNumbery;i++)
 {
  if(TempHist[i]!=-1)
  {
  if((abs(TempHist[i]-tempLL)<45)||(abs(TempHist[i]-tempLL)>=314))
    {
     xAverage[2]=xAverage[2]+XSLocation[i];
     yAverage[2]=yAverage[2]+YSLocation[i];
    MDirection[2]++;
    }
  }
 }
if(MDirection[2]==0)
 {MDirection[2]=1;
 }
xAverage[2]=xAverage[2]/MDirection[2];
yAverage[2]=yAverage[2]/MDirection[2];
tempLL=(tempLL+90)%360;
fDirection[3]=(float)tempLL;
for(i=0;i<VecNumberx*VecNumbery;i++)
 {
  if(TempHist[i]!=-1)
  {
  if((abs(TempHist[i]-tempLL)<45)||(abs(TempHist[i]-tempLL)>=314))
    {
     xAverage[3]=xAverage[3]+XSLocation[i];
     yAverage[3]=yAverage[3]+YSLocation[i];
    MDirection[3]++;
    }
  }
 }
if(MDirection[3]==0)
 {MDirection[3]=1;
 }
xAverage[3]=xAverage[3]/MDirection[3];
yAverage[3]=yAverage[3]/MDirection[3];
//------------------------------------------
float fTempDir;
int iTempDir;
fTempDir=fDirection[0];
iTempDir=MDirection[0];
for (i=1;i<4;i++)
 {
   if(MDirection[i]>iTempDir)
     {
      iTempDir=MDirection[i];
      fTempDir=fDirection[i];
     }
 }
//---------

int iExactLocation[30*30];
int iExactNumber=0;
for (i=0;i<VecNumberx*VecNumbery;i++)
 {
   if(TempHist[i]!=-1)
     {
//       if((abs(TempHist[i]-fTempDir)<45)||(abs(TempHist[i]-fTempDir)>=315))
       if((abs(TempHist[i]-tempL)<45)||(abs(TempHist[i]-tempL)>=315))
         {
           iExactLocation[iExactNumber]=i;
           iExactNumber++;
         }
     }
 }


//--------


//--------
//----------------------------------------------


for(i=0;i<VecNumberx*VecNumbery;i++)
 {
  if(TempHist[i]!=-1)
  {
   if((abs(TempHist[i]-tempL)>ErrorDegree)&&(abs(TempHist[i]-tempL)<=(359-ErrorDegree)))
     {
      //XELocation[i]=XSLocation[i];
      //YELocation[i]=YSLocation[i];
      FalseNumber++;
     }
  }
 }
unsigned char jZoomOrNot;
jZoomOrNot=0;

for(i=0;i<4;i++)
 {
 if(MDirection[i]>=((VecNumberx*VecNumbery-jStillNumber-jErraseNumber)/5))
   { jZoomOrNot++;
   }
 }
/*
if(jZoomOrNot>=2)
{
      //--------
      float fxDist,fxDist1,fyDist,fyDist1;
      int iNDegree,iPDegree;
      iNDegree=iPDegree=0;
      for ( int i=0;i<iExactNumber;i++)
       {
         for (int j=i;j<iExactNumber;j++)
           {
              fxDist=pow((YSLocation[iExactLocation[i]]-YSLocation[iExactLocation[j]]),2);
              fxDist1=pow((XSLocation[iExactLocation[i]]-XSLocation[iExactLocation[j]]),2);
              fxDist=fxDist+fxDist1;
              //---
              fyDist=pow((XELocation[iExactLocation[i]]-XELocation[iExactLocation[j]]),2);
              fyDist1=pow((YELocation[iExactLocation[i]]-YELocation[iExactLocation[j]]),2);
              fyDist=fyDist+fyDist1;
              if(fxDist>fyDist)
               {
                 iPDegree++;
               }
              else if (fxDist<fyDist)
               {
                 iNDegree++;
               }
           }
       }

//--------

    if(iPDegree>iNDegree)
      {
       return( ZOOM_OUT);

      }
    else if(iPDegree<iNDegree)
      {
       return(ZOOM_IN);
      }
    else
      {
       return(IRREGULAR);
      }
}

*/

if(jZoomOrNot>=2)
 {
  if((xAverage[0]<wide/2)&&(yAverage[0]<height/2))
   {
    if((tempL>90)&&(tempL<180))
      {
       return(ZOOM_IN);
      }
    else if((tempL>270)&&(tempL<360))
      {
       return(ZOOM_OUT);
      }
    else
      {
        return(IRREGULAR);
      }
   }
  else if((xAverage[0]>wide/2)&&(yAverage[0]<height/2))
   {
    if((tempL>0)&&(tempL<90))
      {
       return(ZOOM_IN);
      }
    else if((tempL>180)&&(tempL<270))
      {
       return(ZOOM_OUT);
      }
    else
      {
        return(IRREGULAR);
      }

   }
  else if((xAverage[0]<wide/2)&&(yAverage[0]>height/2))
   {
    if((tempL>180)&&(tempL<270))
      {
       return(ZOOM_IN);
      }
    else if((tempL>0)&&(tempL<90))
      {
       return(ZOOM_OUT);
      }
    else
      { 
        return(IRREGULAR);
      }

   }
  else if((xAverage[0]>wide/2)&&(yAverage[0]>height/2))
   {
    if((tempL>270)&&(tempL<360))
      {
       return(ZOOM_IN);
      }
    else if((tempL>90)&&(tempL<180))
      {
       return(ZOOM_OUT);
      }
    else
      { 
        return(IRREGULAR);
      }

   }
 }
else
 {
  return(IRREGULAR);
 }


if(FalseNumber>=VecNumberx*VecNumbery/2)
 {return(IRREGULAR);
  
 }
return(IRREGULAR);
}
//----------------------------------------------------------------------
int TMotionVector::ErraseIrregularPoint(int *Input)
{
int HJLocation;
int ErraseAngle;
ErraseAngle=60;
unsigned char jFlagg1,jFlagg[4];
jErraseNumber=0;
int *Input1;
Input1=new int[VecNumberx*VecNumbery];
memcpy(Input1,Input,VecNumberx*VecNumbery*4);
for(int i=0;i<VecNumbery;i++)
  { for(int j=0;j<VecNumberx;j++)
      {
      if(Input1[i*VecNumberx+j]!=-1)
       { //1
        jFlagg1=jFlagg[0]=jFlagg[1]=jFlagg[2]=jFlagg[3]=0;
        if(j!=0)
          {
           HJLocation=abs(Input1[i*VecNumberx+j]-Input1[i*VecNumberx+j-1]);
           if((HJLocation>ErraseAngle)&&(HJLocation)<(359-ErraseAngle))
             {jFlagg[0]=1;
             }
          }
        else
          {jFlagg[0]=1;}
        if(j!=VecNumberx-1)
          {
           HJLocation=abs(Input1[i*VecNumberx+j]-Input1[i*VecNumberx+j+1]);
           if((HJLocation>ErraseAngle)&&(HJLocation)<(359-ErraseAngle))
             {jFlagg[1]=1;
             }
          }
        else
          {jFlagg[1]=1;}
        if(i!=0)
          {
           HJLocation=abs(Input1[(i-1)*VecNumberx+j]-Input1[i*VecNumberx+j]);
           if((HJLocation>ErraseAngle)&&(HJLocation)<(359-ErraseAngle))
             {jFlagg[2]=1;
             }
          }
        else
          {jFlagg[2]=1;}
        if(i!=VecNumbery-1)
          {
           HJLocation=abs(Input1[(i+1)*VecNumberx+j]-Input1[i*VecNumberx+j]);
           if((HJLocation>ErraseAngle)&&(HJLocation)<(359-ErraseAngle))
             {jFlagg[3]=1;
             }
          }
        else
          {jFlagg[3]=1;}
        for(int k=0;k<4;k++)
          {if(jFlagg[k]==1)
             {jFlagg1++;
             }
          }
       if(jFlagg1>=2)
          {
          jErraseNumber++;
          Input[i*VecNumberx+j]=-1;
          XELocation[i*VecNumberx+j]=XSLocation[i*VecNumberx+j];
          YELocation[i*VecNumberx+j]=YSLocation[i*VecNumberx+j];
          }
       }//1
      }
  }
if(jErraseNumber>=VecNumberx*VecNumbery/2)
 {return(-1);
 }
return(1);
}
//----------------------------------------------------------------------
int TMotionVector::TwoFrameSame(unsigned char *Start,unsigned char *End,int wide, int height)
{
float jThresholdH;


jThresholdH=0;
for(int i1=0;i1<height;i1++)
   { for(int j=0;j<wide;j++)
     {
      jThresholdH=jThresholdH+abs(Start[i1*wide+j]-End[i1*wide+j]);
     }
  }
jThresholdH=jThresholdH/(height*wide);
if(jThresholdH<=15)
 {
  return(-1);
 }
return(1);

}
//----------------------------------------------------------------------
//----------------------------------------------------------------------
int TMotionVector::NewTwoFrameSame(unsigned char *Start,unsigned char *End)
{
float jThresholdH;
jThresholdH=0;
for(int i1=0;i1<height;i1++)
   { for(int j=0;j<wide;j++)
     {
      jThresholdH=jThresholdH+abs(Start[i1*wide+j]-End[i1*wide+j]);
     }
  }
jThresholdH=jThresholdH/(height*wide);
if(jThresholdH<=1)
 {
  return(-1);
 }
return(1);

}

//----------------------------------------------------------------------
//----------------------------------------------------------------------
