// Video.h: interface for the CVideo class.
//
//////////////////////////////////////////////////////////////////////

#include "global.h"
#include "Frame.h"
#include "TMotionBetweenFrames.h"

#include "MyScrollView.h"

#if !defined(AFX_VIDEO_H__B849954F_7D2F_476B_98E1_3874941B1479__INCLUDED_)
#define AFX_VIDEO_H__B849954F_7D2F_476B_98E1_3874941B1479__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CVideo  
{
public:
	void specialEffects_WriteLastPart();
	void calcFeatures_InitCounters();
	int skippedBs;		// the number of B frames come before the first P in the mpeg sequence. frame id = frame no in display - this number
	CFrame * frameBuff;
	float sceneCutThreshold;	// sceneCut threshold
	int noFrame;		// the number of frames currently in the video object
	CFrame* frameSeq[MCHUNCK];	// the current loaded frames
	int noReadFrame;	// the total number of the frame read from the file
	CFile *openedFile;	// the opened file
	float *HD;			// array of HD for each frame

	// data for the shot features
	float sCHAvg[COLQUANT],sCHMin[COLQUANT],sCMAvg[CM_DIM],sHSVAvg[HSV_DIM],sHSVMin[HSV_DIM];
	float sCLAvg[CL_DIM],sCLMin[CL_DIM],sTTAvg[TT_DIM],sTEAvg[TE_DIM],sTEMin[TE_DIM];
	float sHTAvg[HT_DIM],sSCAvg[COLQUANT],sEHAvg[EH_DIM],sMHTotal[9];
	
	int shotMotionType[8];
	TMotionBetweenFrames motion;
	int lastMotionType, lastMotionStartFrame, lastMotionEndFrame, IRStartFrame, IREndFrame, crtMotionType, crtMotionStartFrame, crtMotionEndFrame;

	CVideo (CString fileName);
	CVideo();
	virtual ~CVideo();
	void processVideo(CMyScrollView* downV);
	int initialize();
	int readChunck(int &eof);
	void readNextFrame(CFrame * &crtFrame, int & eoVideo);
	void processChunck(float &maxHD);
	void storeChunckData();
	void makeFinalProcessing(float maxHD);
	void clearVideo();
	void finalAnalysis();
	void specialEffects(CFrame * &crtFrame, CFrame * &prevFrame, unsigned char * crtY, unsigned char *prevY);
	void calcFeatures(CFrame *crtFrame, CArchive &MVAr);
	//void calcFeatures_CH_DC(CFrame *crtFrame);
	void calcFeatures_MH(CArchive & MHAr,CFrame* crtFrame);
	void calcFeatures_WriteShot();
	void finalAnalysis_Init(long &noOfFrames);

};

#endif // !defined(AFX_VIDEO_H__B849954F_7D2F_476B_98E1_3874941B1479__INCLUDED_)
