// VideoDBDoc.cpp : implementation of the CVideoDBDoc class
//

#include "stdafx.h"
#include "VideoDB.h"

#include "VideoDBDoc.h"
#include "frame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int g_Image_H;
int g_Image_W;
int g_noFrames;
BOOL	g_sceneCuts;
BOOL	g_keyFrames;
BOOL	g_spatialSeg;
BOOL	g_specialEffects;
BOOL	g_temporalSeg;
BOOL	g_features;
BOOL	g_CH, g_CH2, g_CM, g_CL, g_TT, g_TE, g_MH, g_DC, g_SC, g_HT, g_EH;
CString g_metadataFile;

int g_chunckSize;
int g_noFramesInRow;
int g_shotNo;	// the current shot number
int g_shotEnd;	// the frame number of the end of the shot
int g_shotStart;// the frame number of the start of the shot
int g_videoId;
//long g_lastSceneCutOffset, g_lastSceneCutOffset2 ; // the byte offset of the last scenecut frame and another copy of it to prevent changing it before it's used
//long g_curSceneCutOffset;	// the byte offset of the current scene cut
//long g_lastIFrameOffset;	// the offset of the last I-Frame found

CFile* g_outputFiles[NOOFFILES];
CVideo* g_video;

// for MPEG decoding
CMpvDecoder MpvDecoder;
BYTE *pnOutBuf;
const HEADERDATA *pHeaderData;


// define global variables used for the plotting
// define the rectangles where each output will appear
RECT rectArea[6];

/////////////////////////////////////////////////////////////////////////////
// CVideoDBDoc

IMPLEMENT_DYNCREATE(CVideoDBDoc, CDocument)

BEGIN_MESSAGE_MAP(CVideoDBDoc, CDocument)
	//{{AFX_MSG_MAP(CVideoDBDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoDBDoc construction/destruction

CVideoDBDoc::CVideoDBDoc()
{
	// TODO: add one-time construction code here

}

CVideoDBDoc::~CVideoDBDoc()
{
	delete (video);
}

BOOL CVideoDBDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CVideoDBDoc serialization

void CVideoDBDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
		CString fileName = ar.GetFile()->GetFilePath();

		if (MpvDecoder.Initialize(fileName) != MDC_SUCCESS)
		{
			AfxMessageBox("Error Initialize the MPEG decoder");
			_exit(0);
		}

		pHeaderData=MpvDecoder.GetMpvHeaders();
		if (!pHeaderData->bGOPValid)
		{
			AfxMessageBox("Error in Header files");
			return ;
		}

		// allocate output buffer, should be larger than the largest possible output.
		pnOutBuf=new BYTE [(long)(pHeaderData->SequenceHeader.wHorizontalSize+2)*
						(pHeaderData->SequenceHeader.wVerticalSize+2)*3+4096];
		if (pnOutBuf==NULL)	
		{
			AfxMessageBox("ERROR : Memory allocation failed !");
			return;
		}

		// creating new video object
		video = new CVideo(fileName);
		g_video = video;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CVideoDBDoc diagnostics

#ifdef _DEBUG
void CVideoDBDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CVideoDBDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

